package com.sun.jndi.toolkit.ctx;

import javax.naming.Name;
import javax.naming.directory.SearchControls;
import javax.naming.directory.SearchResult;
import javax.naming.NamingEnumeration;
import javax.naming.directory.DirContext;
import javax.naming.directory.ModificationItem;
import javax.naming.NamingException;
import javax.naming.directory.Attributes;

public abstract class AtomicDirContext extends ComponentDirContext
{
    protected AtomicDirContext() {
        this._contextType = 3;
    }
    
    protected abstract Attributes a_getAttributes(String p0, String[] p1, Continuation p2) throws NamingException;
    
    protected abstract void a_modifyAttributes(String p0, int p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract void a_modifyAttributes(String p0, ModificationItem[] p1, Continuation p2) throws NamingException;
    
    protected abstract void a_bind(String p0, Object p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract void a_rebind(String p0, Object p1, Attributes p2, Continuation p3) throws NamingException;
    
    protected abstract DirContext a_createSubcontext(String p0, Attributes p1, Continuation p2) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> a_search(Attributes p0, String[] p1, Continuation p2) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> a_search(String p0, String p1, Object[] p2, SearchControls p3, Continuation p4) throws NamingException;
    
    protected abstract NamingEnumeration<SearchResult> a_search(String p0, String p1, SearchControls p2, Continuation p3) throws NamingException;
    
    protected abstract DirContext a_getSchema(Continuation p0) throws NamingException;
    
    protected abstract DirContext a_getSchemaClassDefinition(Continuation p0) throws NamingException;
    
    protected Attributes a_getAttributes_nns(String s, String[] array, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected void a_modifyAttributes_nns(String s, int n, Attributes attributes, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_modifyAttributes_nns(String s, ModificationItem[] array, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_bind_nns(String s, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected void a_rebind_nns(String s, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
    }
    
    protected DirContext a_createSubcontext_nns(String s, Attributes attributes, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> a_search_nns(Attributes attributes, String[] array, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> a_search_nns(String s, String s2, Object[] array, SearchControls searchControls, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected NamingEnumeration<SearchResult> a_search_nns(String s, String s2, SearchControls searchControls, Continuation continuation) throws NamingException {
        this.a_processJunction_nns(s, continuation);
        return null;
    }
    
    protected DirContext a_getSchema_nns(Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    protected DirContext a_getSchemaDefinition_nns(Continuation continuation) throws NamingException {
        this.a_processJunction_nns(continuation);
        return null;
    }
    
    @Override
    protected Attributes c_getAttributes(Name name, String[] array, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_getAttributes(name.toString(), array, continuation);
        }
        return null;
    }
    
    @Override
    protected void c_modifyAttributes(Name name, int n, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_modifyAttributes(name.toString(), n, attributes, continuation);
        }
    }
    
    @Override
    protected void c_modifyAttributes(Name name, ModificationItem[] array, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_modifyAttributes(name.toString(), array, continuation);
        }
    }
    
    @Override
    protected void c_bind(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_bind(name.toString(), o, attributes, continuation);
        }
    }
    
    @Override
    protected void c_rebind(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            this.a_rebind(name.toString(), o, attributes, continuation);
        }
    }
    
    @Override
    protected DirContext c_createSubcontext(Name name, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_createSubcontext(name.toString(), attributes, continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search(Name name, Attributes attributes, String[] array, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_search(attributes, array, continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search(Name name, String s, SearchControls searchControls, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_search(name.toString(), s, searchControls, continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search(Name name, String s, Object[] array, SearchControls searchControls, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context(name, continuation)) {
            return this.a_search(name.toString(), s, array, searchControls, continuation);
        }
        return null;
    }
    
    @Override
    protected DirContext c_getSchema(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_getSchema(continuation);
        }
        return null;
    }
    
    @Override
    protected DirContext c_getSchemaClassDefinition(Name name, Continuation continuation) throws NamingException {
        if (this.resolve_to_context(name, continuation)) {
            return this.a_getSchemaClassDefinition(continuation);
        }
        return null;
    }
    
    @Override
    protected Attributes c_getAttributes_nns(Name name, String[] array, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            return this.a_getAttributes_nns(name.toString(), array, continuation);
        }
        return null;
    }
    
    @Override
    protected void c_modifyAttributes_nns(Name name, int n, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            this.a_modifyAttributes_nns(name.toString(), n, attributes, continuation);
        }
    }
    
    @Override
    protected void c_modifyAttributes_nns(Name name, ModificationItem[] array, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            this.a_modifyAttributes_nns(name.toString(), array, continuation);
        }
    }
    
    @Override
    protected void c_bind_nns(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            this.a_bind_nns(name.toString(), o, attributes, continuation);
        }
    }
    
    @Override
    protected void c_rebind_nns(Name name, Object o, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            this.a_rebind_nns(name.toString(), o, attributes, continuation);
        }
    }
    
    @Override
    protected DirContext c_createSubcontext_nns(Name name, Attributes attributes, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            return this.a_createSubcontext_nns(name.toString(), attributes, continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, Attributes attributes, String[] array, Continuation continuation) throws NamingException {
        this.resolve_to_nns_and_continue(name, continuation);
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, String s, SearchControls searchControls, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            return this.a_search_nns(name.toString(), s, searchControls, continuation);
        }
        return null;
    }
    
    @Override
    protected NamingEnumeration<SearchResult> c_search_nns(Name name, String s, Object[] array, SearchControls searchControls, Continuation continuation) throws NamingException {
        if (this.resolve_to_penultimate_context_nns(name, continuation)) {
            return this.a_search_nns(name.toString(), s, array, searchControls, continuation);
        }
        return null;
    }
    
    @Override
    protected DirContext c_getSchema_nns(Name name, Continuation continuation) throws NamingException {
        this.resolve_to_nns_and_continue(name, continuation);
        return null;
    }
    
    @Override
    protected DirContext c_getSchemaClassDefinition_nns(Name name, Continuation continuation) throws NamingException {
        this.resolve_to_nns_and_continue(name, continuation);
        return null;
    }
}
